# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite if we don't have File::Path ≥ 2.08
%global old_file_path %(perl -MFile::Path -e 'print (($File::Path::VERSION < 2.08) ? 1 : 0);' 2>/dev/null || echo 0)

Summary:	A fast and simple mbox folder reader
Name:		perl-Mail-Mbox-MessageParser
Version:	1.5105
Release:	6.%{__distinit}%{__distvers}
License:	GPLv2
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Mail-Mbox-MessageParser/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DC/DCOPPIT/Mail-Mbox-MessageParser-%{version}.tar.gz
Source1:	perl-module-version-filter
Patch0:		Mail-Mbox-MessageParser-1.5102-old-File::Path.patch
Patch1:		Mail-Mbox-MessageParser-1.5105-rt103835.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	grep, gzip, bzip2, xz, /usr/bin/diff
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Config)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(ExtUtils::Manifest)
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(URI::Escape)
BuildRequires:	perl(warnings)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(FileHandle::Unget)
BuildRequires:	perl(Storable)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
# Test Suite
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Slurp)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(FileHandle)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Text::Diff)
# Optional Tests
BuildRequires:	perl(Test::Pod) >= 1.00
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	grep, gzip, bzip2, xz, /usr/bin/diff
Requires:	perl(Storable)

# lzip available from EL-5, F-9, but version prior to F-11 is too old
%if 0%{?fedora} > 10 || 0%{?rhel} > 4
BuildRequires:	lzip >= 1.3
Requires:	lzip >= 1.3
%endif

%description
Mail::Mbox::MessageParser is a feature-poor but very fast mbox parser. It uses
the best of three strategies for parsing a mailbox: either using cached folder
information, GNU grep, or highly optimized Perl.

%prep
%setup -q -n Mail-Mbox-MessageParser-%{version}

# We need to patch the test suite if we don't have File::Path ≥ 2.08
%if %{old_file_path}
%patch0
%endif

# Very strange test failure using File::Temp in object mode on perl 5.8
# https://rt.cpan.org/Public/Bug/Display.html?id=103835
%patch1

# Auto provides aren't clever enough for what Mail::Mbox::MessageParser does
%if 0%{?__perllib_provides:1}
%global provfilt /bin/sh -c "%{__perllib_provides} | perl -n -s %{SOURCE1} -lib=%{_builddir}/%{buildsubdir}/lib"
%global __perllib_provides %{provfilt}
%else
%global provfilt /bin/sh -c "%{__perl_provides} | perl -n -s %{SOURCE1} -lib=%{_builddir}/%{buildsubdir}/lib"
%global __perl_provides %{provfilt}
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor \
	BZIP=/usr/bin/bzip2 \
	BZIP2=/usr/bin/bzip2 \
	CAT=/bin/cat \
	DIFF=/usr/bin/diff \
	GREP=/bin/grep \
	GZIP=/bin/gzip \
%if 0%{?fedora} > 10 || 0%{?rhel} > 4
	LZIP=/usr/bin/lzip \
%else
	LZIP= \
%endif
	XZ=/usr/bin/xz

make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc anonymize_mailbox CHANGES README TODO
%{perl_vendorlib}/Mail/
%{_mandir}/man3/Mail::Mbox::MessageParser.3*
%{_mandir}/man3/Mail::Mbox::MessageParser::Cache.3*
%{_mandir}/man3/Mail::Mbox::MessageParser::Grep.3*
%{_mandir}/man3/Mail::Mbox::MessageParser::MetaInfo.3*
%{_mandir}/man3/Mail::Mbox::MessageParser::Perl.3*

%changelog
* Fri Sep  2 2016 Paul Howarth <paul@city-fan.org> - 1.5105-6
- BR: perl-generators where available
- Simplify find command using -delete

* Tue Jan 26 2016 Paul Howarth <paul@city-fan.org> - 1.5105-4
- Prefer %%global over %%define

* Mon Jun 22 2015 Paul Howarth <paul@city-fan.org> - 1.5105-3
- Perl 5.22 rebuild

* Sun May  3 2015 Paul Howarth <paul@city-fan.org> - 1.5105-1
- Update to 1.5105
  - Prevent CPAN from indexing private-lib
- Update workaround for t/filehandle_compressed.t with 5.8

* Mon Apr 20 2015 Paul Howarth <paul@city-fan.org> - 1.5104-1
- Update to 1.5104
  - Add File::Path dependency for testing (CPAN RT#103482)
  - Don't install private Module::Install extension (CPAN RT#103482)
  - Clarify licensing terms
  - Move verbose testing to a private module, and implement it in a way that
    doesn't require editing the Makefile after it is generated
  - Require File::Slurp instead of including it, to avoid potential problems
    like this:
    http://www.cpantesters.org/cpan/report/86a0145a-e52b-11e4-a1d1-8536eb4f9f07
  - Improve the ability of the test suite to be run in parallel
  - Fix Windows test incompatibilities, such as:
    http://www.cpantesters.org/cpan/report/12187014-af8d-1014-92d8-fdf72a825c07
    http://www.cpantesters.org/cpan/report/12187014-af8d-1014-92d8-fdf72a825c07
- Add workaround for strange test failure in t/filehandle_compressed.t with 5.8

* Mon Apr 13 2015 Paul Howarth <paul@city-fan.org> - 1.5102-1
- Update to 1.5102
  - Fix xz and lzip test skip for when tools are not installed
  - Enable verbose testing for CPAN-testers
  - Use proper temp dir instead of t/temp
  - Consolidate issue tracking at rt.cpan.org
- License changed to GPLv2
- Remove file installed by accident (CPAN RT#103482)
- Add patch to support building with File::Path < 2.08

* Sun Mar 29 2015 Paul Howarth <paul@city-fan.org> - 1.5101-1
- Update to 1.5101
  - Add a version check for lzip, to make sure the .lz file can be decompressed
    properly during testing
  - Fix warning about deleting nonexistent test cache
  - Enhance "make test TEST_VERBOSE=1" to dump debug information
  - Work around a POD-stripping bug that would cause module load to fail on
    some platforms

 Wed Mar 25 2015 Paul Howarth <paul@city-fan.org> - 1.5100-2
- BR:/R: lzip ≥ 1.3; version 1.1 is too old to decompress test files from
  grepmail, version 1.7 works OK and version 1.3 is probably the one needed
  judging by the lzip ChangeLog

* Mon Mar 23 2015 Paul Howarth <paul@city-fan.org> - 1.5100-1
- Update to 1.5100
  - Moved code to github
  - Added xz support (CPAN RT#68286)
  - Added lzip support (http://sourceforge.net/p/grepmail/patches/8/)
  - Added POD test
  - Fixed hang in pure Perl implementation for a malformed mbox file scenario
  - Fixed $OLDSTDERR used only once warning (CPAN RT#58053)
  - Fixed enabling of warnings (CPAN RT#79898)
  - Fixed a division by zero error for malformed mbox files that start with a
    newline (CPAN RT#69469)
  - Fix bug in M::M::Perl documentation
  - Add more cache file validation
- Classify buildreqs by usage
- Add patch to fix build error (CPAN RT#103025)

* Tue Sep  2 2014 Paul Howarth <paul@city-fan.org> - 1.5002-17
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Tue Jul  3 2012 Paul Howarth <paul@city-fan.org> - 1.5002-11
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 1.5002-6
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix provides filter to work with rpm 4.9 onwards
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 1.5002-5
- Rebuild for perl 5.12.1 in Rawhide

* Tue Jun  1 2010 Paul Howarth <paul@city-fan.org> - 1.5002-4
- Fix used-only-once warning that breaks grepmail with perl 5.12.0

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> - 1.5002-3
- Fix dist tag for RHEL-6 Beta

* Thu Feb 18 2010 Paul Howarth <paul@city-fan.org> - 1.5002-2
- Fix versioned provides for perl modules
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation

* Tue Sep  1 2009 Paul Howarth <paul@city-fan.org> - 1.5002-1
- Update to 1.5002
  - Perl 5.10 patch upstreamed
  - Disable the grep interface, known to be buggy
  - Fix infinite loop in emails of less than 200 characters (CPAN RT#33493)
  - Update Makefile.PL for versions of Module::Install > 0.88
  - Instead of returning an error for an empty mailbox, a valid mailbox is
    returned that immediately fails the end_of_mailbox check (CPAN RT#43665)
  - Fix missing "m" modifier issue exposed by Perl 5.10 (CPAN RT#33004)
  - Added some debugging information for the "cache data not validated" error
  - Fix an off-by-one error that could cause warnings about undefined values
- Upstream source back on search.cpan.org
- BuildRequire perl(Test::More) and perl(Text::Diff)
- Define RPM macros in global scope

* Tue Nov  4 2008 Paul Howarth <paul@city-fan.org> - 1.5000-2
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Clarify license as GPL (unspecified version)
- Fix for perl 5.10 (Andreas Koenig)

* Fri Jan 12 2007 Paul Howarth <paul@city-fan.org> - 1.5000-1
- Update to 1.5000
- Fix dist tag for development builds
- Fix argument order for find with -depth
- Permission fixes no longer needed in %%prep

* Fri Aug 25 2006 Paul Howarth <paul@city-fan.org> - 1.4005-1
- Update to 1.4005

* Wed Jul 12 2006 Paul Howarth <paul@city-fan.org> - 1.4004-1
- Update to 1.4004

* Mon May 22 2006 Paul Howarth <paul@city-fan.org> - 1.4003-1
- Update to 1.4003
- Define %%{__id_u} in a more portable way

* Fri Feb 10 2006 Paul Howarth <paul@city-fan.org> - 1.4002-1
- Update to 1.4002
- Remove tzip support altogether (dropped upstream)
- Simplify distribution-detection code
- Remove __perl_package macro, used only twise
- Remove __perl_version macro, used only once
- Remove buildroot unconditionally in %%clean and %%install
- Don't use macros in build-time command paths, hardcode them instead
- Add dependency on /usr/bin/diff
- Use --default option when running Makefile.PL to avoid having to edit out
  Benchmark::Timer reference
- Use better %%summary

* Wed Aug 10 2005 Paul Howarth <paul@city-fan.org> - 1.4001-2
- Disable tzip support by default; tzip support will be disappearing upstream
  soon anyway

* Thu Aug  4 2005 Paul Howarth <paul@city-fan.org> - 1.4001-1
- Update to 1.4001

* Wed Jul 13 2005 Paul Howarth <paul@city-fan.org> - 1.4000-1
- Update to 1.4000
- Remove optimization settings from %%build, not needed for noarch package
- Fix directory ownership issues
- Fix module permission issues
- Include anonymize_mailbox script as %%doc

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> - 1.3001-1
- Update to 1.3001
- Don't set LANG for testing; problem probably fixed upstream now

* Wed May 18 2005 Paul Howarth <paul@city-fan.org> - 1.3000-2
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Fri Apr  1 2005 Paul Howarth <paul@city-fan.org> - 1.3000-1
- Update to 1.3000
- Default to --with tzip instead of --without tzip
- Run tests in "C" locale to avoid breakage

* Wed Dec 22 2004 Paul Howarth <paul@city-fan.org> - 1.2130-1
- Update to 1.2130

* Fri Sep 17 2004 Paul Howarth <paul@city-fan.org> - 1.21-1
- Update to 1.21.1
- Hack Makefile.PL to prevent prompting to install Benchmark::Timer module
  if it's not present

* Sat Jul 31 2004 Paul Howarth <paul@city-fan.org> - 1.20-1
- Update to 1.20
- Moved `make test' into %%check section
- General tidy up of spec file

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> - 1.14-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> - 1.14-2
- Unified spec file for Red Hat and Fedora Core

* Tue Feb 10 2004 Paul Howarth <paul@city-fan.org> - 1.14-1.fc1
- Update to 1.14
- Added optional tzip support (with "--with tzip" option to rpmbuild)

* Fri Dec 12 2003 Paul Howarth <paul@city-fan.org> - 1.12-1.fc1
- More macros
- Added Fedora Core version to RPM release ID

* Tue Nov 25 2003 Paul Howarth <paul@city-fan.org> - 1.12-1
- Update to 1.12

* Mon Nov 24 2003 Paul Howarth <paul@city-fan.org> - 1.10-1
- Initial RPM build
